#region Copyright

/*
 * Copyright 2005-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */

#endregion

using System;
using Seasar.WindowsExample.Logics.Dao;
using Seasar.WindowsExample.Logics.Dto;

namespace Seasar.WindowsExample.Logics.Service.Impl
{
    /// <summary>
    /// Јo^pT[rXpC^[tFCX
    /// </summary>
    public class EmployeeEditServiceImpl : BaseServiceImpl, IEmployeeEditService
    {
        /// <summary>
        /// ЈDAO
        /// </summary>
        private IEmployeeDao _dao;

        /// <summary>
        /// RXgN^
        /// </summary>
        public EmployeeEditServiceImpl()
        {
            ;
        }

        /// <summary>
        /// ЈDAO
        /// </summary>
        public IEmployeeDao DaoOfEmp
        {
            get { return _dao; }
            set { _dao = value; }
        }

        /// <summary>
        /// Јf[^擾
        /// </summary>
        /// <param name="id">ЈID</param>
        /// <returns>Јf[^</returns>
        public EmployeeDto GetData(int id)
        {
            return ( _dao.GetData(id) );
        }

        /// <summary>
        /// Јf[^o^
        /// </summary>
        /// <param name="data">o^Јf[^</param>
        /// <returns>o^</returns>
        public int ExecUpdate(EmployeeDto data)
        {
            if ( data == null )
                throw new ArgumentNullException("data");

            if ( data.Id.HasValue )
            {
                EmployeeDto e1 = _dao.GetData(data.Id.Value);
                if ( e1 != null )
                    return ( _dao.UpdateData(data) );
                else
                    return ( _dao.InsertData(data) );
            }
            else
            {
                return ( _dao.InsertData(data) );
            }
        }

        /// <summary>
        /// Јf[^폜
        /// </summary>
        /// <param name="id">폜ЈID</param>
        /// <returns>폜</returns>
        public int ExecDelete(int id)
        {
            EmployeeDto data = new EmployeeDto();
            data.Id = id;

            return ( _dao.DeleteData(data) );
        }
    }
}